Page MenuHomePhabricator

Evas font: add comparison for fallbacks in evas_font_desc_cmp()
ClosedPublic

Authored by id213sin on Feb 17 2016, 2:26 AM.

Details

Summary

fallbacks string also has to be compared to load proper fdesc.
If a font which does not have fallback fonts is loaded,
fallback fonts can't be appended to the same font.
@fix

Diff Detail

Repository
rEFL core/efl
Lint
Automatic diff as part of commit; lint not applicable.
Unit
Automatic diff as part of commit; unit tests not applicable.
id213sin updated this revision to Diff 8489.Feb 17 2016, 2:26 AM
id213sin retitled this revision from to Evas font: add comparison for fallbacks in evas_font_desc_cmp().
id213sin updated this object.
id213sin edited the test plan for this revision. (Show Details)
id213sin added reviewers: tasn, herdsman, woohyun.

@herdsman
Thanks for sharing your test result.
After applying this patch, you can see infinite loop in any test case(using textblock style or markup tags) from D3703.

tasn edited edge metadata.Feb 17 2016, 4:43 AM

I'm starting to think me letting the patch introducing fallbacks in was a mistake. :|

@tasn
There was an requirement for setting a font including its proper fallback fonts.
So, I found "font_fallbacks" keyword and introduced it to developers.
But, there was some bugs. So, I made bug fix patches about this feature. :(

tasn added a comment.Feb 18 2016, 6:23 AM

I'm talking about font_callbacks in font_desc, which is what this patch is about, it's following the previous patch, no?

@tasn
Yes, it is following to previous patch.
But, the both patches are made for enriching and fixing the existing font_fallbacks feature.
Even if the previous patch(which is for support ":fallbacks=") was not accepted,
this patch has to be checked for the existing font_fallbacks feature.

If Evas does not compare fdesc including fallbacks, you can see font_fallbacks does not work in many cases.
(Once the font is loaded, fallback fonts for the same main font with same font size are never appended.)

id213sin edited edge metadata.Mar 21 2016, 3:58 AM
id213sin added subscribers: z-wony, Blackmole.
zmike requested changes to this revision.May 2 2018, 3:23 PM
zmike added a subscriber: zmike.

This needs a rebase.

@herdsman

This revision now requires changes to proceed.May 2 2018, 3:23 PM
zmike added a project: efl.May 2 2018, 3:25 PM
herdsman accepted this revision.Jun 28 2018, 8:11 AM

This will be pushed after D3703

This revision was not accepted when it landed; it landed in state Needs Revision.Jul 2 2018, 3:53 AM
This revision was automatically updated to reflect the committed changes.